# -----------------------------------------------------------------------------
sub infHDR
{
  ($thishost) = @_;

  if ($up[$thishost] ne "Y")
  {
    &logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (substr($sw_version[$thishost],0,1) lt "7")
  {
    &logit("HDR checking only works on Informix version >= 7",$thishost);
    return 0;
  }

  if ($dr_status[$thishost] ne "(Sec)" && $dr_status[$thishost] ne "(Prim)")
  {
    $msg = sprintf("HDR Check N/A - Status = %s",$dr_status[$thishost]);
    &logit($msg,$thishost);
    return 0;
  }

  ##print os_version[$thishost]
  ##print substr(os_version[$thishost],1,1) 

  if (substr($os_version[$thishost],0,1) eq "0")
  {
    logit("HDR checking only works on HP-UX version >= 10",$thishost);
    return 0;
  }

  #
  # Run query against sysdri
  #

  &remsh("onstat -;export PATH=\$PATH:$infdir[$thishost]/bin;$probe[$thishost] hdr",$tmpfl2,$thishost);
  if ($up[$thishost] ne "Y")
  {
    &logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  $hdrok = 1;

  open(TMPFL2, "$tmpfl2"  ) || &error_msg("Can't open input $tmpfl2 - $!");
  while(<TMPFL2>)
  {
    &parse;
    #print $0
    if ($F1 eq "type")   { $hdr_type  = $F2 }
    if ($F1 eq "state")  { $hdr_state = $F2 }
    if ($F1 eq "name")   { $hdr_name  = $F2 }
  }
  close(TMPFL2);
  
  if (($hdr_type eq "Primary" && $hdr_state ne "On") || ($hdr_type eq "Secondary" && $hdr_state ne "Read-Only"))
  {
    &event("C",$thishost,"HDR Not Active - Type=$hdr_type State=$hdr_state Name=hdr_name","HDR","DBA331C",$tmpfl2);
    $hdrok = 0;
  }

  #
  # 3.20I - 
  # There is a bug in Informix which forces us to run a
  #  dbspaceset=* backup when we have to do the HDR turn-on restore.
  #  We have found that it is difficult to remember to change our backup tool
  #  back to parallel backups after performing one of these special backups.
  #  A new check has been added to the infHDR() routine which will create
  #  a warning event if:
  #    1. The most recent level-0 backup is a dbspaceset=* backup -and-
  #    2. HDR is active
  #

  ## This event is no longer needed
  ##if ($mrl0dsid[$thishost] == 0 && $hdr_type eq "Primary")
  ##{
  ##  &event("W",$thishost,"Normal Backup Schedule Not In Place","BkupSched","DBA380W",$tmpfl2);
  ##  $check_flag = 1;
  ##  $hdrok = 0;
  ##}

  if ($hdrok)
  {
    logit("OK",$thishost);
  }
}
# -----------------------------------------------------------------------------
1;
