# -----------------------------------------------------------------------------
# Changes:
#   BB 14Mar06 - Initial
# -----------------------------------------------------------------------------
sub oraAuditSes
{
  ($thishost) = @_;

  my $thissub_raw = ( caller( 0 ) )[ 3 ];
  my $thissub     = (split(/\:/,$thissub_raw)) [2];

  if (&check_inhib($thishost) eq "Y" || $up[$thishost] eq "I")
  {
    $up[$thishost] = "I";
    &logit("(down/inhibited)",$thishost);
    return;
  }

  if ($asmflag[$thishost])
  {
    &logit("(This check not applicable to +ASM instance)",$thishost);
    return 1;
  }

  if ($up[$thishost] eq "D")
  {
    &logit("No software download)",$thishost);
    return;
  }

  if ($up[$thishost] ne "Y")
  {
    logit("(Down)",$thishost);
    return 1;
  }

  if ($audit_ses_check[$thishost] eq "N")
  {
    logit("(Audit_Ses: Set to N)",$thishost);
    return 1;
  }

  if ($oraAuditSesStack[$thishost] eq "")
  {
    &logit("No Audit Session Data for this instance",$thishost);
    return;
  }

  #open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
  #print TMPFL6 $diagAuditSesStack[$thishost];
  #close(TMPFL6);

  $zfqhost = $fqhostname[$thishost];
  $zfqhost = $hostname[$thishost] if ! $zfqhost;

  #---- Process any new audit session data
  @lines = split(/\n/,$oraAuditSesStack[$thishost]);
  foreach (@lines)
  {
    &parse;
    
    $aud_id  = $F4;
    $aud_ts  = $F5;
    $aud_cnt = $F6;
    ##print "DEBUG $thissub - aud_id=$aud_id aud_ts=$aud_ts aud_cnt=$aud_cnt\n";


    $sql = "delete 
      from 
        dbamon.instance_users 
      where 
        as_dbamonmode = '$modeout' 
        and as_fqhostname = '$zfqhost' 
        and as_instance   = '$orasid[$thishost]' 
        and as_id         = '$aud_id'
    ";
    ##print "DEBUG delete sql=$sql\n";
    &runSQL($sql);

    $sql  = "
      insert into dbamon.instance_users
        (as_dbamonmode,
         as_fqhostname,
         as_instance,
         as_id,
         as_last_ts
        )
      values
        (\'$modeout\',
         \'$zfqhost\',
         \'$orasid[$thishost]\',
         \'$aud_id\',
         to_date('$aud_ts','YYYY/MM/DD-HH24:MI:SS') 
        )
    ";
    ##print "DEBUG insert sql=$sql\n";
    &runSQL($sql);
  }

  #---- Select the max audit session timestamp for this instance
  $sql  = "select
      to_char(max(as_last_ts),\'YYYY/MM/DD-HH24:MI:SS\'),
      sysdate - max(as_last_ts)
    from 
      dbamon.instance_users
    where
      as_dbamonmode = '$modeout' 
      and as_fqhostname = '$zfqhost' 
      and as_instance   = '$orasid[$thishost]' 
  ";

  ##print "sql=$sql\n";
  $sth2 = $dbh->prepare($sql) || &error_msg('Failed_on_DB_prepare_in_chgEnt');
  $sth2->execute || &error_msg('Failed_on_DB_execute_in_chgEnt');

  while (@Data = $sth2->fetchrow_array)
  {
    $i++;

    $aud_max_ts      = $Data[0];
    $aud_ts_age_days = sprintf "%.3f",$Data[1];

  }
  print "DEBUG - $zfqhost/$orasid[$thishost] aud_max_ts=$aud_max_ts aud_ts_age_days=$aud_ts_age_days\n";

  &logDetails($thishost,"<h3>Oracle Session Audit Data</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=antiquewhite>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");
  &logDetails($thishost,"<tr><td>$f_s<b>Most Recent User Session Create:</b> <td>$f_s $aud_max_ts <td>$f_s");
  &logDetails($thishost,"<tr><td>$f_s<b>Days Since Most Recent User Session:</b> <td>$f_s $$aud_ts_age_days <td>$f_s");
  &logDetails($thishost,"</table><hr>");

  &logit("Done - $thissub",$thishost);
}
# -----------------------------------------------------------------------------
1;
